Index: lib/spatial/mapbuilder/lib/widget/Loading2.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Loading2.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Loading2.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Loading2.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -26,33 +26,25 @@
   WidgetBase.apply(this,new Array(widgetNode, model));
 
   //loading img to be displayed  while models load
-  var imageSrc = widgetNode.selectSingleNode("mb:imageSrc");
-  if (imageSrc) {
-    this.imageSrc = config.skinDir + imageSrc.firstChild.nodeValue;
-  } else {
-    this.imageSrc = config.skinDir + "/images/Loading.gif";
-  }
+  this.imageSrc = config.skinDir + this.getProperty("mb:imageSrc", "/images/Loading.gif");
 
   //a text message to be displayed while models load
-  var textMessage = widgetNode.selectSingleNode("mb:textMessage");
-  if (textMessage) {
-    this.textMessage = textMessage.firstChild.nodeValue;
-  } else {
-    this.textMessage = "Document loading, please wait...";
-  }
+  this.textMessage = this.getProperty("mb:textMessage", mbGetMessage("docLoading"));
   this.updateMessage = this.textMessage;
 
   //check to see if this is to be put over a map if there isa mapContainerID supplied
-  var mapContainerNode = widgetNode.selectSingleNode("mb:mapContainerId");
-  if (mapContainerNode) {
-    this.containerNodeId = mapContainerNode.firstChild.nodeValue;
-    this.node = document.getElementById(this.containerNodeId);
+  this.mapContainerNode = widgetNode.selectSingleNode("mb:mapContainerId");
+  if (!this.mapContainerNode) {
+    this.mapContainerNode = widgetNode.selectSingleNode("mb:targetModel");
   }
+  if (this.mapContainerNode) {
+    this.containerNodeId = getNodeValue(this.mapContainerNode);
+    this.htmlTagId = this.containerNodeId;
+  }
 
   //paint it on the "newModel" event, clear it on "loadModel" event
   this.model.addListener("newModel",this.paint, this);
   this.model.addListener("loadModel",this.clear, this);
-  this.model.addListener("bbox", this.paint, this );
   this.model.addListener("refresh",this.paint, this);
   this.model.addListener("modelStatus",this.update, this);
 }
@@ -62,19 +54,27 @@
  * @param objRef Pointer to widget object.
  */
 Loading2.prototype.paint = function(objRef) {
-  if (objRef.node) {
+  var node = objRef.getNode();
+  if (node) {
+    //if it is a template model, no loader should be shown in the output div
+    if (objRef.model.template) return;
+    //if there's no url, there will never be an update on the ModelStatus, so the image stays while nothing is happening.
+    if (!objRef.model.url && !objRef.mapContainerNode) return;
     //create the output node the first time this is called
     var outputNode = document.getElementById( objRef.outputNodeId+"_loading" );
     if (!outputNode) {
       outputNode = document.createElement("div");
       outputNode.setAttribute("id",objRef.outputNodeId+"_loading");
-      objRef.node.appendChild(outputNode);
+      node.appendChild(outputNode);
     }
     outputNode.className = "loadingIndicator";
-    outputNode.style.zindex = 1000;
-    outputNode.style.position="absolute";
-    outputNode.style.left='0px';
-    outputNode.style.top='0px';
+    outputNode.style.zIndex = 10001;
+    //In a mapcontainer you want the loader in the left top, in other widgets embedded in the output area
+    if (objRef.mapContainerNode){
+      outputNode.style.position="absolute";
+      outputNode.style.left='0px';
+      outputNode.style.top='0px';
+    }
     if (objRef.imageSrc) {
       var imageNode = document.getElementById( objRef.outputNodeId+"_imageNode" );
       if (!imageNode) {
@@ -81,7 +81,7 @@
         imageNode = document.createElement("img");
         imageNode.setAttribute("id",objRef.outputNodeId+"_imageNode");
         outputNode.appendChild(imageNode);
-        imageNode.style.zindex = 1000;
+        imageNode.style.zIndex = 10001;
       }
       imageNode.src = objRef.imageSrc;
     }
@@ -101,9 +101,10 @@
  * Remove the contents of the HTML tag for this widget.
  * @param objRef Reference to this object.
  */
-Loading2.prototype.clear= function(objRef) {
+Loading2.prototype.clear= function(objRef, message) {
   var outputNode = document.getElementById( objRef.outputNodeId+"_loading" );
-  if (outputNode) objRef.node.removeChild(outputNode);
+  var node = objRef.getNode();
+  if (node && outputNode) node.removeChild(outputNode);
 }
 
 /**
@@ -112,8 +113,8 @@
  * @param objRef Reference to this object.
  */
 Loading2.prototype.update= function(objRef, message) {
+  objRef.updateMessage = message || null;
   if (message) {
-    objRef.updateMessage = message;
     objRef.paint(objRef);
   } else {
     objRef.clear(objRef);
Index: lib/spatial/mapbuilder/lib/widget/SelectAllMapLayers.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectAllMapLayers.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/SelectAllMapLayers.xsl	(revision 4307)
@@ -1,34 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-<!--
-Description: link to load the WMS Capabilities doc as a context document.  
-            This works with the Caps2Context tool which implements the listener
-Author:      adair
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-$Id$
-$Name$
--->
-
-<xsl:stylesheet version="1.0" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-    xmlns:wms="http://www.opengis.net/wms"
-		xmlns:ogc="http://www.opengis.net/ogc"
-    xmlns:xlink="http://www.w3.org/1999/xlink">
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-  <!-- The coordinates of the DHTML Layer on the HTML page -->
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-  
-  <!-- template rule matching source root element -->
-  <xsl:template match="/WMT_MS_Capabilities | /wms:WMS_Capabilities">
-    <p>
-      <a href="javascript:config.objects.{$modelId}.setParam('mapAllLayers')">map all layers</a>
-    </p>
-  </xsl:template>
-
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wms="http://www.opengis.net/wms" xmlns:ogc="http://www.opengis.net/ogc" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:template match="/WMT_MS_Capabilities | /wms:WMS_Capabilities"><p><a href="javascript:config.objects.{$modelId}.setParam('mapAllLayers')">map all layers</a></p></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/MapScaleText.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/MapScaleText.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/MapScaleText.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: MapScaleText.js 3242 2007-09-11 11:15:21Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -26,8 +26,9 @@
    * Handles submission of the form (via javascript in an <a> tag or onsubmit handler)
    */
   this.submitForm = function() {
-    var newScale = this.mapScaleTextForm.mapScale.value;
-    this.model.extent.setScale(newScale.split(",").join(""));
+    var mapScaleTextForm = document.getElementById(this.formName);
+    var newScale = mapScaleTextForm.mapScale.value;
+    this.model.map.zoomToScale(newScale.split(",").join(""));
     return false;   //prevent the form from actually being submitted
   }
 
@@ -60,8 +61,9 @@
    * @param objRef Pointer to this widget object.
    */
   this.showScale = function(objRef) {
-    if (objRef.mapScaleTextForm) {
-      var newScale = Math.round(objRef.model.extent.getScale());
+    var mapScaleTextForm = document.getElementById(objRef.formName);
+    if (mapScaleTextForm) {
+      var newScale = Math.round(objRef.model.map.getScale());
       var parts = new Array();
       while (newScale>=1000.0) {
         var newPart = newScale/1000.0;
@@ -70,7 +72,7 @@
         parts.unshift(strPart);
       }
       parts.unshift(newScale);
-      objRef.mapScaleTextForm.mapScale.value = parts.join(",");
+      mapScaleTextForm.mapScale.value = parts.join(",");
     }
   }
 
@@ -94,9 +96,9 @@
    * @param objRef Pointer to this CurorTrack object.
    */
   this.postPaint = function(objRef) {
-    objRef.mapScaleTextForm = document.getElementById(objRef.formName);
-    objRef.mapScaleTextForm.parentWidget = objRef;
-    objRef.mapScaleTextForm.onkeypress = objRef.handleKeyPress;
+    var mapScaleTextForm = document.getElementById(objRef.formName);
+    mapScaleTextForm.parentWidget = objRef;
+    mapScaleTextForm.onkeypress = objRef.handleKeyPress;
     objRef.showScale(objRef);
   }
 
Index: lib/spatial/mapbuilder/lib/widget/TransactionResponse.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TransactionResponse.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/TransactionResponse.xsl	(revision 4307)
@@ -1,98 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-<!--
-
-Description: Render a WFS Transaction Response.
-
-Author:      Cameron Shorter
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
-$Name$
-
--->
-
-
-
-<xsl:stylesheet
-
-  version="1.0"
-
-  xmlns:ogc="http://www.opengis.net/ogc"
-
-  xmlns:wfs="http://www.opengis.net/wfs"
-
-  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-
-
-  <xsl:output method="xml"/>
-
-
-
-  <!-- template rule matching source root element -->
-
-  <xsl:template match="/">
-
-    <div>
-
-      <xsl:apply-templates/>
-
-    </div>
-
-  </xsl:template>
-
-
-
-  <!-- Service Exception -->
-
-  <xsl:template match="ogc:ServiceException">
-
-    <table>
-
-      <tr>
-
-        <td>Service Exception:</td>
-
-        <td><xsl:apply-templates/></td>
-
-      </tr>
-
-    </table>
-
-  </xsl:template>
-
-
-
-  <!-- Transaction Response -->
-
-  <xsl:template match="wfs:WFS_TransactionResponse">
-
-    <table>
-
-      <tr>
-
-        <td>Transaction Status:</td>
-
-        <td><xsl:value-of select="name(wfs:TransactionResult/wfs:Status/*)"/></td>
-
-      </tr>
-
-      <tr>
-
-        <td>New Feature Id:</td>
-
-        <td><xsl:value-of select="wfs:InsertResult/ogc:FeatureId/@fid"/></td>
-
-      </tr>
-
-    </table>
-
-  </xsl:template>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:ogc="http://www.opengis.net/ogc" xmlns:wfs="http://www.opengis.net/wfs" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes"/><xsl:template match="/"><div><xsl:apply-templates/></div></xsl:template><xsl:template match="ogc:ServiceException"><table><tr><td>Service Exception:</td><td><xsl:apply-templates/></td></tr></table></xsl:template><xsl:template match="wfs:WFS_TransactionResponse"><table><tr><td>Transaction Status:</td><td><xsl:value-of select="name(wfs:TransactionResult/wfs:Status/*)"/></td></tr><xsl:if test="wfs:InsertResult/ogc:FeatureId/@fid"><tr><td>New Feature Id:</td><td><xsl:value-of select="wfs:InsertResult/ogc:FeatureId/@fid"/></td></tr></xsl:if></table></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.xsl	(revision 4307)
@@ -1,52 +1,3 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0"
-xmlns:wmc="http://www.opengis.net/context"
-xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder"
-xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Displays the Title value from a Web Map Context document
-Author:      Mike Adair
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
-$Name$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <!-- The coordinates of the DHTML Layer on the HTML page -->
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-  
-  <xsl:param name="lang">en</xsl:param>
-  <xsl:param name="layerName">TEMPERATURE</xsl:param>
-
-  <!-- Main html -->
-  
-  <xsl:template match="/wmc:ViewContext/wmc:General/wmc:Extension ">
-    <div>
-      <form>
-        start:<select name="firstFrame" onchange="config.objects.{$modelId}.setParam('firstFrame',this.value)">
-          <xsl:apply-templates select="mb:TimestampList[@layerName=$layerName]/mb:Timestamp"/>
-        </select>
-        <!--
-        - stop:<select name="lastFrame" onchange="config.objects.{$widgetId}.setLastFrame(this.value)">
-          <xsl:apply-templates select="wmc:TimestampList[@layerName=$layerName]/wmc:Timestamp"/>
-        </select>
-        -->
-      </form>
-    </div>
-  </xsl:template>
-  
-  <xsl:template match="mb:Timestamp">
-    <xsl:param name="index" select="position()-1"/>
-    <option value="{$index}">
-      <xsl:value-of select="."/>
-    </option>
-  </xsl:template>
-  
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:wmc="http://www.opengis.net/context" xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="lang">en</xsl:param><xsl:param name="layerId">TEMPERATURE</xsl:param><xsl:template match="/wmc:ViewContext/wmc:General/wmc:Extension "><div><form>
+        start:<select name="firstFrame" onchange="config.objects.{$modelId}.setParam('firstFrame',this.value)"><xsl:apply-templates select="mb:TimestampList[@layerId=$layerId]/mb:Timestamp"/></select></form></div></xsl:template><xsl:template match="mb:Timestamp"><xsl:param name="index" select="position()-1"/><option value="{$index}"><xsl:value-of select="."/></option></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/Button.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Button.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Button.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Button.js 3052 2007-08-01 21:25:21Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -7,10 +7,10 @@
 mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
 
 /**
- * Generic Button object.  Set the <action> property in config for the controller
- * method to be called when selected
+ * Generic Button object. Set the <action> property in config for
+ * the controller method to be called when selected
  * @base ButtonBase
- * @author Mike Adair mike.adairATccrs.nrcan.gc.ca
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
  * @param widgetNode      The tool node from the Config XML file.
  * @param model  The ButtonBar widget.
  */
@@ -17,6 +17,54 @@
 function Button(widgetNode, model) {
   ButtonBase.apply(this, new Array(widgetNode, model));
 
+  /**
+   * default css cursor to use when the button is selected
+   */
+  this.cursor = 'default';
+
+  /**
+   * Creates the OpenLayers control for this button.
+   * This method will be called by ButtonBase when
+   * MapPaneOL is ready to have buttons added.
+   * The control should be defined in this method.
+   * @type function
+   * @param objRef reference to this object.
+   * @return class (not instance!) of the OL control.
+   */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.'+objRef.id,
+      type: (objRef.buttonType == 'RadioButton') ? OpenLayers.Control.TYPE_TOOL : OpenLayers.Control.TYPE_BUTTON,
+      // for button type      
+      trigger: function() {
+        eval('config.objects.'+objRef.action);
+      },
+      // for tool type (RadioButton)
+      activate: function() {
+        eval('config.objects.'+objRef.action);
+        this.active = true;
+        return true;
+      }
+    });
+    return Control;
+  }
+  
+  /**
+   * Optional method to instantiate the control. If a
+   * subclass provides this method, it will be used instead
+   * of just callint new Control() in the superclass.
+   * This is needed when a control has to be instantiated
+   * with parameters.
+   * @type OpenLayers.Control
+   * @param objRef reference to this object.
+   * @param {OpenLayers.Control} Control to instantiate
+   * @return instance of the OL control
+   */
+  this.instantiateControl = function(objRef, Control) {
+    // return OpenLayers.Control instance
+    return new Control();
+    
+  }
 }
 
 
Index: lib/spatial/mapbuilder/lib/widget/SetAoi.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SetAoi.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/SetAoi.js	(revision 4307)
@@ -1,39 +1,82 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: SetAoi.js 3052 2007-08-01 21:25:21Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
 
 /**
- * When this button is selected, the AOI box stays visible and no zoom happens. 
- * @constructor
+ * Set AOI button.
  * @base ButtonBase
- * @author Mike Adair 
- * @param widgetNode The widget node from the Config XML file.
- * @param model  The model for this widget
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param widgetNode      The tool node from the Config XML file.
+ * @param model  The ButtonBar widget.
  */
 function SetAoi(widgetNode, model) {
+   ButtonBase.apply(this, new Array(widgetNode, model));
 
-  // Extend ButtonBase
-  ButtonBase.apply(this, new Array(widgetNode, model));
+  this.cursor = 'crosshair';
 
-  // override default cursor by user
-  // cursor can be changed by spefying a new cursor in config file
-  this.cursor = "crosshair";
-
   /**
-   * The action to do on click
-   * @param objRef      Pointer to this object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
+   * Interactive ZoomOut control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
    */
-  this.doAction = function(objRef,targetNode) {
-    //does nothing for the moment
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.SetAoi',
+      type: OpenLayers.Control.TYPE_TOOL,
+
+      draw: function() {
+        this.handler = new OpenLayers.Handler.Box( this,
+              {done: this.aoiBox}, {keyMask: this.keyMask} );
+      },
+
+      aoiBox: function (position) {
+        if (position instanceof OpenLayers.Bounds) {
+          var minXY = this.map.getLonLatFromPixel(
+               new OpenLayers.Pixel(position.left, position.bottom));
+          var maxXY = this.map.getLonLatFromPixel(
+               new OpenLayers.Pixel(position.right, position.top));
+          var bounds = new OpenLayers.Bounds(minXY.lon, minXY.lat,
+               maxXY.lon, maxXY.lat);
+          var bboxOL = bounds.toBBOX().split(',');
+          var ul = new Array(bboxOL[0],bboxOL[3]);
+          var lr = new Array(bboxOL[2],bboxOL[1]);
+          objRef.targetContext.setParam("aoi", new Array(ul, lr));
+          objRef.drawAoiBox(objRef);
+        }
+      }
+    });
+ 
+    // adds a listener to the context to clear the AOI box when AOI changes
+    this.targetContext.addListener('aoi', this.clearAoiBox, this);
+
+    return Control;
   }
 
-  if (this.mouseHandler) {
-    this.mouseHandler.model.addListener('mouseup',this.doAction,this);
+  /**
+   * Draws a bounding box around the current AOI.
+   * @param objRef reference to this widget
+   */
+  this.drawAoiBox = function(objRef) {
+    var ext = objRef.targetContext.getParam('aoi');
+    var bounds = new OpenLayers.Bounds(ext[0][0], ext[1][1], ext[1][0], ext[0][1]);
+    objRef.targetContext.aoiBoxLayer = new OpenLayers.Layer.Boxes('Boxes');
+    objRef.targetContext.map.addLayer(objRef.targetContext.aoiBoxLayer);
+    var box = new OpenLayers.Marker.Box(bounds);
+    objRef.targetContext.aoiBoxLayer.addMarker(box);
   }
-}
-
+  
+  /**
+   * Clears the AOI box.
+   * @param objRef reference to this widget
+   */
+  this.clearAoiBox = function(objRef) {
+    if (objRef.targetContext.aoiBoxLayer) {
+      objRef.targetContext.aoiBoxLayer.destroy();
+    }  
+  }
+}
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/widget/ModelUrlInput.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ModelUrlInput.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ModelUrlInput.js	(revision 4307)
@@ -2,11 +2,11 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: ModelUrlInput.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
-mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
 
 /**
  * Widget to display the a form to input any model's URL and load the new URL 
@@ -21,6 +21,9 @@
 function ModelUrlInput(widgetNode, model) {
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
 
+  //a default value to be used in the form
+  this.defaultUrl = this.getProperty("mb:defaultUrl");
+
   /**
    * Handles submission of the form (via javascript in an <a> tag)
    */
@@ -34,7 +37,7 @@
         httpPayload.method = httpMethod[i].value;
         if (httpPayload.method.toLowerCase() == "post") {
           httpPayload.postData = null; //TBD get this from somewhere? or not allow post?
-          if (this.debug) alert("postData:"+httpPayload.postData.xml);
+          mbDebugMessage(this, "postData:"+httpPayload.postData.xml);
         } else {
           httpPayload.postData = null;
         }
@@ -75,6 +78,8 @@
    */
   this.prePaint = function(objRef) {
     objRef.stylesheet.setParameter("modelTitle", objRef.targetModel.title);
+    if (!objRef.defaultUrl) objRef.defaultUrl = objRef.targetModel.url;
+    objRef.stylesheet.setParameter("defaultUrl", objRef.defaultUrl);
   }
 
   /**
Index: lib/spatial/mapbuilder/lib/widget/GmlRendererBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/GmlRendererBase.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/GmlRendererBase.js	(revision 4307)
@@ -0,0 +1,59 @@
+/*
+Author:       Andreas Hocevar andreas.hocevarATgmail.com
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: GmlRendererBase.js 3887 2008-02-27 18:18:53Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
+
+/**
+ * Render GML into HTML.
+ * this.targetModel references the context model for the map
+ * where the content of this widget should be rendered to.
+ * If the model doc is not wfs compliant, a stylesheet
+ * property has to be set for this widget. The xsl file
+ * referenced in this property transforms the model doc to
+ * a wfs FeatureCollection.
+ * @constructor
+ * @base WidgetBase
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function GmlRendererBase(widgetNode, model) {
+  WidgetBase.apply(this,new Array(widgetNode, model));
+  
+  // set the feature srs.
+  /** SRS of the features that this widget will render */
+  this.featureSRS = this.getProperty('mb:featureSRS');
+  
+  // set the hover cursor.
+  /** css cursor when hovering over features */
+  this.hoverCursorNode = this.getProperty('mb:hoverCursor', 'pointer');
+
+  /** model holding the sld for feature styles of this widget */
+  this.sldModelNode = widgetNode.selectSingleNode('mb:sldModel');
+
+  // set the default style.
+  /** sld node within the sld model that is used for default styling */
+  this.defaultStyleName = this.getProperty('mb:defaultStyleName', 'default');
+  
+  // set the select style
+  /** sld node within the sld model that is used when a feature is hovered */
+  this.selectStyleName = this.getProperty('mb:selectStyleName', 'selected');
+
+  /**
+   * config object holding all configurations that might be different
+   * among source models (if a MergeModel with multiple GmlRendererConfig
+   * widgets is used).
+   */
+  this.config = new Object({
+        model: model,
+        hoverCursor: this.hoverCursor,
+        sldModelNode: this.sldModelNode,
+        defaultStyleName: this.defaultStyleName,
+        selectStyleName: this.selectStyleName,
+        featureSRS: this.featureSRS
+  });
+}
Index: lib/spatial/mapbuilder/lib/widget/FeatureInfo.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/FeatureInfo.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/FeatureInfo.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: FeatureInfo.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -9,7 +9,7 @@
 /**
  * Functions to render and update a FeatureInfoResponse from GML.
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @author Steven Ottens AT geodan nl
  * @param widgetNode  The widget's XML object node from the configuration document.
  * @param model       The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/widget/Version.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Version.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Version.xsl	(revision 4307)
@@ -1,36 +1,2 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0"
-xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Displays the mapbuilder version.
-Author:      Cameron Shorter
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
-$Name$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <xsl:param name="version">$Name$</xsl:param>
-  <xsl:param name="version1" select="substring-after($version,'mapbuilder-lib-')"/>
-  <xsl:param name="version2" select="normalize-space(substring-before($version1,'$'))"/>
-
-  <!-- Main html -->
-  <xsl:template match="/">
-    <div>
-      <xsl:choose>
-        <xsl:when test="$version2">              
-          <xsl:value-of select="$version2"/>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:text>CVS Head</xsl:text>
-        </xsl:otherwise>
-      </xsl:choose>
-    </div>
-  </xsl:template>
-  
-  <xsl:template match="text()|@*"/>
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:template match="/"><div>1.5-rc2</div></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/GetFeatureInfoWSR.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/GetFeatureInfoWSR.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/GetFeatureInfoWSR.js	(revision 4307)
@@ -0,0 +1,106 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+Dependancies: Context
+$Id: GetFeatureInfoWSR.js 3887 2008-02-27 18:18:53Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+/**
+ * Implements GetFeatureInfo functionality, using the WebServiceRequest
+ * tool. This will work with the WMS:GetFeatureInfo request as well as
+ * with WFS:GetFeature. This widget can be used as an example on how to
+ * write widgets that use the WebServiceRequest functionality.
+ * @constructor
+ * @base ButtonBase
+ * @author adair
+ * @constructor
+ * @param widgetNode The XML node in the Config file referencing this object.
+ * @param model The widget object which this widget is associated with.
+ */
+function GetFeatureInfoWSR(widgetNode, model) {
+  // Extend ButtonBase
+  ButtonBase.apply(this, new Array(widgetNode, model));
+  
+  /** WebServiceRequest controller for this widget */
+  this.controller = this.getProperty("mb:controller");
+  
+  /**
+   * tolerance in pixels around the click point for WFS:GetFeature
+   * default is 3
+   */
+  this.tolerance = parseFloat(this.getProperty("mb:tolerance", 3));
+  
+  /**
+   * GetFeatureInfoWSR control
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
+   */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.GetFeatureInfoWSR',
+      type: OpenLayers.Control.TYPE_TOOL
+    });
+    return Control;
+  }
+  
+  /**
+   * Register click event when button is selected, unregister it when
+   * unselected
+   * @param objRef reference to this widget
+   * @param selected true if button is selected, false otherwise
+   */
+  this.doSelect = function(objRef, selected) {
+    if (selected) {
+      objRef.targetModel.map.events.register('click', objRef, objRef.doOnClick);  
+    } else {
+      objRef.targetModel.map.events.unregister('click', objRef, objRef.doOnClick);  
+    }
+  }
+  
+  /**
+   * For GetFeatureInfo, we want to check for queryable layers and only use
+   * those.
+   * @param e OpenLayers click event
+   */
+  this.doOnClick = function(e) {
+    objRef = this;
+    if (!objRef.enabled) return;
+    var controller = config.objects[objRef.controller];
+    var layerNameList = new Array();
+    var selectedLayer=objRef.targetModel.getParam("selectedLayer");
+    var queryList;
+    if (!selectedLayer) {
+      queryList = objRef.targetModel.getQueryableLayers();
+      if (queryList.length==0) {
+         alert(mbGetMessage("noQueryableLayers"));
+         return;
+      }
+    } else {
+      queryList = [objRef.targetModel.getLayer(selectedLayer)];
+    }
+    
+    var llPx = e.xy.add(-objRef.tolerance, objRef.tolerance);
+    var urPx = e.xy.add(objRef.tolerance, -objRef.tolerance);
+    
+    var ll = objRef.targetModel.map.getLonLatFromPixel(llPx);
+    var ur = objRef.targetModel.map.getLonLatFromPixel(urPx);
+    
+    for (var i=0; i<queryList.length; ++i) {
+      var layerNode = queryList[i];
+
+      // Get the name of the layer
+      var layerName = Mapbuilder.getProperty(layerNode, "wmc:Name", "");
+
+      var hidden = objRef.targetModel.getHidden(layerName);
+      if (hidden == 0) { //query only visible layers
+        controller.requestStylesheet.setParameter("bBoxMinX", ll.lon);
+        controller.requestStylesheet.setParameter("bBoxMinY", ll.lat);
+        controller.requestStylesheet.setParameter("bBoxMaxX", ur.lon);
+        controller.requestStylesheet.setParameter("bBoxMaxY", ur.lat);
+        controller.requestStylesheet.setParameter("queryLayer", layerName);
+        objRef.targetModel.setParam(controller.requestName.replace(/:/,"_"), layerName);
+      }
+    }
+  }
+}
